import 'package:flutter/material.dart';
import 'package:unify_api/unify.dart';

class AddLeadExample extends StatefulWidget {
  AddLeadExample({
    @required this.client,
    this.lead,
  });
  final UnifyClient client;
  final LeadDetails lead;
  @override
  _AddLeadExampleState createState() => _AddLeadExampleState();
}

class _AddLeadExampleState extends State<AddLeadExample> {
  final TextEditingController _firstName = TextEditingController();
  final TextEditingController _middleName = TextEditingController();
  final TextEditingController _lastName = TextEditingController();
  final TextEditingController _suffix = TextEditingController();
  final TextEditingController _secFirstName = TextEditingController();
  final TextEditingController _secMiddleName = TextEditingController();
  final TextEditingController _secLastName = TextEditingController();
  final TextEditingController _email = TextEditingController();

  @override
  void initState() {
    _firstName.text = widget?.lead?.firstName ?? "";
    _middleName.text = widget?.lead?.middleName ?? "";
    _lastName.text = widget?.lead?.lastName ?? "";
    _secFirstName.text = widget?.lead?.secondaryFirstName ?? "";
    _secMiddleName.text = widget?.lead?.secondaryMiddleName ?? "";
    _secLastName.text = widget?.lead?.secondaryLastName ?? "";
    _email.text = widget?.lead?.email ?? "";
    _suffix.text = widget?.lead?.suffix ?? "";
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(widget?.lead == null ? "Add Lead" : "Edit Lead"),
      ),
      body: SingleChildScrollView(
        child: Column(
          mainAxisSize: MainAxisSize.min,
          children: <Widget>[
            ListTile(
              title: TextField(
                controller: _firstName,
                decoration: InputDecoration(hintText: "First Name"),
              ),
            ),
            ListTile(
              title: TextField(
                controller: _middleName,
                decoration: InputDecoration(hintText: "Middle Name"),
              ),
            ),
            ListTile(
              title: TextField(
                controller: _lastName,
                decoration: InputDecoration(hintText: "Last Name"),
              ),
            ),
            ListTile(
              title: TextField(
                controller: _suffix,
                decoration: InputDecoration(hintText: "Suffix"),
              ),
            ),

            ListTile(
              title: TextField(
                controller: _secFirstName,
                decoration: InputDecoration(hintText: "Secondary First Name"),
              ),
            ),
            ListTile(
              title: TextField(
                controller: _secMiddleName,
                decoration: InputDecoration(hintText: "Secondary Middle Name"),
              ),
            ),
            ListTile(
              title: TextField(
                controller: _secLastName,
                decoration: InputDecoration(hintText: "Secondary Last Name"),
              ),
            ),
            ListTile(
              title: TextField(
                controller: _email,
                decoration: InputDecoration(hintText: "Email Address"),
              ),
            ),

            // _value == null
            //     ? ListTile(
            //         title: Text("Loading..."),
            //         trailing: CircularProgressIndicator(),
            //       )
            //     : DropdownButtonFormField(
            //         items: _responses
            //             .map((r) => DropdownMenuItem<CompanyCategory>(
            //                   value: r,
            //                   child: Text(r?.name ?? ""),
            //                 ))
            //             .toList(),
            //         value: _value,
            //         onChanged: (CompanyCategory value) {
            //           setState(() {
            //             _value = value;
            //           });
            //         },
            //       ),
            RaisedButton.icon(
              icon: Icon(Icons.save),
              label: Text("Save"),
              onPressed: () => Navigator.pop(
                  context,
                  LeadDetails(
                    widget.client,
                    {
                      "First_Name": _firstName.text,
                      "Middle_Name": _middleName.text,
                      "Last_Name": _lastName.text,
                      "Suffix": _suffix.text,
                      // "Lead_Priority": contactPriority ?? 0,
                      "Secondary_First_Name": _secFirstName.text,
                      "Secondary_Middle_Name": _secMiddleName.text,
                      "Secondary_Last_Name": _secLastName.text,
                      // "Address": currentAddress,
                      // "Home_Phone": homePhone,
                      // "Office_Phone": officePhone,
                      // "Cell_Phone": cellPhone,
                      // "Secondary_Cell_Phone": secondaryCellPhone,
                      // "Fax_Phone": faxPhone,
                      "Email_Address": _email.text,
                      // "Company_Category": companyCategory?.json,
                      // "Lead_Groups":
                      //     groups?.map((g) => g.json)?.toList() ?? [],
                    },
                    null,
                  )),
            )
          ],
        ),
      ),
    );
  }
}
