import 'package:flutter/material.dart';
import 'package:unify_api/unify.dart';
import 'package:unify_api_example/common/json_view.dart';

class GreatnessTracker extends StatefulWidget {
  final UnifyClient client;
  const GreatnessTracker({Key key, this.client}) : super(key: key);

  @override
  _GreatnessTrackerState createState() => _GreatnessTrackerState();
}

class _GreatnessTrackerState extends State<GreatnessTracker> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text('PreQual/Status tracker'),
      ),
      body: ListView(
        children: [
          ListTile(
              title: Text('PreQual/TBD'),
              onTap: () {
                Navigator.push(
                  context,
                  MaterialPageRoute(
                    builder: (BuildContext context) =>
                        PreQualTBD(client: widget.client),
                  ),
                );
              }),
          ListTile(
              title: Text('Status Update'),
              onTap: () {
                Navigator.push(
                  context,
                  MaterialPageRoute(
                    builder: (BuildContext context) =>
                        StatusUpdateTracker(client: widget.client),
                  ),
                );
              })
        ],
      ),
    );
  }
}

class PreQualTBD extends StatefulWidget {
  final UnifyClient client;

  PreQualTBD({Key key, this.client}) : super(key: key);
  @override
  _PreQualTBDState createState() => _PreQualTBDState();
}

class _PreQualTBDState extends State<PreQualTBD> {
  List<PreQual> _items;
  List<AccountNames> accounts;
  @override
  void initState() {
    // widget.client
    //     .listPreQualTracker(page: 1, rows: 100, loanType: 'PreQual')
    //     .then((preQual) {
    //   setState(() {
    //     _items = preQual;
    //   });
    // });
    // widget.client
    //     .listPreQualTracker(page: 1, rows: 100, loanType: 'PreQual')
    //     .then((tbd) {
    //   setState(() {
    //     _items = tbd;
    //   });
    widget.client.listActiveAccounts().then((value) {
      setState(() {
        accounts = value;
      });
    });
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text('PreQual and TBD'),
      ),
      body: Builder(
        builder: (context) {
          if (_items == null) {
            return Center(child: CircularProgressIndicator());
          }
          if (_items.isEmpty) {
            return Center(child: Text('No contacts in group'));
          }
          return ListView.builder(
            itemCount: _items.length,
            itemBuilder: (context, index) {
              final i = _items[index];
              return ListTile(
                title: Text(i.firstName + i.lastName),
                subtitle: Text(i.emailAddress),
                trailing: JsonButton(json: i?.json),
              );
            },
          );
        },
      ),
    );
  }
}

class StatusUpdateTracker extends StatefulWidget {
  final UnifyClient client;

  StatusUpdateTracker({Key key, this.client}) : super(key: key);
  @override
  _StatusUpdateState createState() => _StatusUpdateState();
}

class _StatusUpdateState extends State<StatusUpdateTracker> {
  List<StatusUpdate> _items;

  @override
  void initState() {
    widget.client.listStatusUpdateTracker(page: 1, rows: 100).then((items) {
      setState(() {
        _items = items;
      });
    });

    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text('Status Update'),
      ),
      body: Builder(
        builder: (context) {
          if (_items == null) {
            return Center(child: CircularProgressIndicator());
          }
          if (_items.isEmpty) {
            return Center(child: Text('No Contacts in this group'));
          }
          return ListView.builder(
              itemCount: _items.length,
              itemBuilder: (context, index) {
                final i = _items[index];
                return ListTile(
                  title: Text(i.firstName + i.lastName),
                  subtitle: Text(i.emailAddress),
                  trailing: JsonButton(json: i?.json),
                );
              });
        },
      ),
    );
  }
}
