part of unify;

class UnifyCache implements UnifyObject {
  UnifyCache(this.client, this.json);

  @override
  final UnifyClient client;

  @override
  final Map<String, dynamic> json;

  AccountInfo get account => AccountInfo(client, json["account_info"]);

  List<Contact> get contacts => json["contacts"] == null
      ? []
      : List.from(json["contacts"]).map((i) => Contact(client, i)).toList();

  List<Lead> get leads => json["leads"] == null
      ? []
      : List.from(json["leads"]).map((i) => Lead(client, i)).toList();

  List<ContactGroup> get contactGroups => json["contact_groups"] == null
      ? []
      : List.from(json["contact_groups"])
          .map((i) => ContactGroup(client, i))
          .toList();

  List<LeadGroup> get leadGroups => json["lead_groups"] == null
      ? []
      : List.from(json["lead_groups"])
          .map((i) => LeadGroup(client, i))
          .toList();

  List<Loan> get loansAll => json["loans_all"] == null
      ? []
      : List.from(json["loans_all"]).map((i) => Loan(client, i)).toList();

  List<Loan> get loansMyPipeline => json["loans_mypipeline"] == null
      ? []
      : List.from(json["loans_mypipeline"])
          .map((i) => Loan(client, i))
          .toList();

  List<Loan> get loansProspects => json["loans_prospects"] == null
      ? []
      : List.from(json["loans_prospects"]).map((i) => Loan(client, i)).toList();

  List<Loan> get loansOther => json["loans_other"] == null
      ? []
      : List.from(json["loans_other"]).map((i) => Loan(client, i)).toList();

  List<Loan> get loansClosed => json["loans_closed"] == null
      ? []
      : List.from(json["loans_closed"]).map((i) => Loan(client, i)).toList();

  List<DashboardAlert> get dashboardOpportunity =>
      json["dashboard_opportunity"] == null
          ? []
          : List.from(json["dashboard_opportunity"])
              .map((i) => DashboardAlert(client, i))
              .toList();

  List<DashboardAlert> get dashboardCustomer =>
      json["dashboard_customer"] == null
          ? []
          : List.from(json["dashboard_customer"])
              .map((i) => DashboardAlert(client, i))
              .toList();

  List<DashboardAlert> get dashboardHotProspects =>
      json["dashboard_hotprospects"] == null
          ? []
          : List.from(json["dashboard_hotprospects"])
              .map((i) => DashboardAlert(client, i))
              .toList();

  List<DashboardAlert> get dashboardPipeline =>
      json["dashboard_pipeline"] == null
          ? []
          : List.from(json["dashboard_pipeline"])
              .map((i) => DashboardAlert(client, i))
              .toList();

  List<Task> get tasksAll => json["tasks_all"] == null
      ? []
      : List.from(json["tasks_all"]).map((i) => Task(client, i)).toList();

  List<Task> get tasksContacts => json["tasks_contacts"] == null
      ? []
      : List.from(json["tasks_contacts"]).map((i) => Task(client, i)).toList();

  List<Task> get tasksLeads => json["tasks_leads"] == null
      ? []
      : List.from(json["tasks_leads"]).map((i) => Task(client, i)).toList();

  List<Video> get videosAll => json["videos_all"] == null
      ? []
      : List.from(json["videos_all"]).map((i) => Video(client, i)).toList();

  List<Video> get videosMy => json["videos_my"] == null
      ? []
      : List.from(json["videos_my"]).map((i) => Video(client, i)).toList();

  List<Video> get videosShared => json["videos_shared"] == null
      ? []
      : List.from(json["videos_shared"]).map((i) => Video(client, i)).toList();

  List<Video> get videosArchived => json["videos_archived"] == null
      ? []
      : List.from(json["videos_archived"])
          .map((i) => Video(client, i))
          .toList();

  List<MarketingSection> get marketingTree => json["marketing_tree"] == null
      ? []
      : List.from(json["marketing_tree"])
          .map((i) => MarketingSection(client, i))
          .toList();

  List<MarketingCampaign> get marketingCampaigns =>
      json["marketing_campaigns"] == null
          ? []
          : List.from(json["marketing_campaigns"])
              .map((i) => MarketingCampaign(client, i))
              .toList();

  List<UnifyAlert> get unifyAlerts => json["unify_alerts"] == null
      ? []
      : List.from(json["unify_alerts"])
          .map((i) => UnifyAlert(client, i))
          .toList();

  DateTime get lastUpdated => DateTime.tryParse(json["last_updated"] as String);

  bool get isStale =>
      lastUpdated.isAfter(DateTime.now().add(Duration(hours: 1)));
}
