part of unify;

class CoreLeadDetails implements UnifyObject {
  CoreLeadDetails(this.client, this.json, this.id);

  @override
  final UnifyClient client;

  @override
  final Map<String, dynamic> json;

  final String id;

  String get coreLeadId => json["Lead_Tracker_Lead_ID"];

    String get contactId => json["Contact_ID"];

  String get fullName => "$firstName $lastName".trim();

  String get displayName => "$lastName, $firstName";

  String get firstName => json["Borrower_First_Name"];

  String get lastName => json["Borrower_Last_Name"];

  PhoneNumber get primaryPhone => PhoneNumber(client, {
        "label": "primary",
        "area_code": json["Borrower_Phone1_Area_Code"],
        "prefix": json["Borrower_Phone1_Prefix"],
        "number": json["Borrower_Phone1_Number"],
      });

  PhoneNumber get secondaryPhone => PhoneNumber(client, {
        "label": "secondary",
        "area_code": json["Borrower_Phone2_Area_Code"],
        "prefix": json["Borrower_Phone2_Prefix"],
        "number": json["Borrower_Phone2_Number"],
      });

  String get email => json["Borrower_Email_Address"];

  PostalAddress get mailingAddress => PostalAddress(client, {
        "label": "mailing",
        "street": json["Mailing_Address1"],
        "apartment": json["Mailing_Address2"],
        "city": json["Mailing_City"],
        "state": json["Mailing_State"],
        "zip": json["Mailing_Zip"],
      });

  String get borrower_Birthdate => json["Borrower_Birthdate"];

  String get borrower_Contact_Preference => json["Borrower_Contact_Preference"];

  String get borrower_Credit_Report_Auth => json["Borrower_Credit_Report_Auth"];

  num get borrower_Credit_Score => json["Borrower_Credit_Score"];

  String get coBorrower_Birthdate => json["CoBorrower_Birthdate"];

  String get coBorrower_Contact_Preference =>
      json["CoBorrower_Contact_Preference"];

  String get coBorrower_Credit_Report_Auth =>
      json["CoBorrower_Credit_Report_Auth"];

  num get coBorrower_Credit_Score => json["CoBorrower_Credit_Score"];

  String get hot_Lead => json["Hot_Lead"];

  String get lead_View => json["Lead_View"];

  String get disposition => json["Disposition"];

  num get property_Value => json["Property_Value"];

  String get propertyState => json["Property_State"];

  String get propertyCity => json["Property_City"];

  num get request_Loan_Amount => json["Request_Loan_Amount"];

  num get request_Purchase_Price => json["Request_Purchase_Price"];

  String get sub_Division_Name => json["Sub_Division_Name"];

  String get new_Home_Sales_Agent => json["New_Home_Sales_Agent"];

  String get date_Pre_Approved => json["Date_PreApproved"];

  String get lead_date => json["Lead_Date"];

  String get real_Deal_Date => json["Read_Deal_Date"];

  String get next_Step => json["Next_Step"];

  String get next_Action_Date => json["Next_Action_Date"];

  String get assign_Lead_To => json["Assign_Lead_To"];

  String get initial_Appointment_Date => json["Initial_Appointment_Date"];

  String get appointment_Type => json["Appointment_Type"];

  String get time_Frame => json["Time_Frame"];

  String get down_Payment => json["Down_Payment"];

  String get is_CoBorrower => json["Is_CoBorrower"];

  String get details_Complete => json["Details_Complete"];

  String get documentation_Complete => json["Documentation_Complete"];

  String get encompass_File_Created => json["Encompass_File_Created"];

  String get lead_Source_Contact_ID => json["Lead_Source_Contact_ID"];

  String get builder_Loan => json["Builder_Loan"];

  String get closing_Date => json["Closing_Date"];

  num get interest_Rate => json["Interest_Rate"];

  num get loan_Amount => json["Loan_Amount"];

  num get appraised_Value => json["Appraised_Value"];

  num get purchase_Price => json["Purchase_Price"];

  num get monthly_Payments => json["Monthly_Payments"];

  num get target_Refi_Rate => json["Target_Refi_Rate"];

  String get loan_Type => json["Loan_Type"];

  String get property_Type => json["Property_Type"];

  String get occupancy => json["Occupancy"];

  String get loanNumber => json["Loan_Number"];

  String get loanPurpose => json["Loan_Purpose"];

  String get cofullName => "$cofirstName $colastName".trim();

  String get codisplayName => "$colastName, $cofirstName";

  String get cofirstName => json["CoBorrower_First_Name"];

  String get colastName => json["CoBorrower_Last_Name"];

  String get leadSource => json["Lead_Source"];

  String get leadSourceType => json["Lead_Source_Type"];

  String get leadSourceName => json["Lead_Source_Name"];

  String get phoneType1 => json["Borrower_Phone1_Type"];

  String get phoneType2 => json["Borrower_Phone2_Type"];

  String get coPhoneType1 => json["CoBorrower_Phone1_Type"];

  String get coPhoneType2 => json["CoBorrower_Phone2_Type"];

  PhoneNumber get coprimaryPhone => PhoneNumber(client, {
        "label": "primary",
        "area_code": json["CoBorrower_Phone1_Area_Code"],
        "prefix": json["CoBorrower_Phone1_Prefix"],
        "number": json["CoBorrower_Phone1_Number"],
      });

  PhoneNumber get cosecondaryPhone => PhoneNumber(client, {
        "label": "secondary",
        "area_code": json["CoBorrower_Phone2_Area_Code"],
        "prefix": json["CoBorrower_Phone2_Prefix"],
        "number": json["CoBorrower_Phone2_Number"],
      });

  PhoneNumber get leadSourceCellPhone => PhoneNumber(client, {
        "label": "cell",
        "area_code": json["Lead_Source_Cell_Phone_Area_Code"],
        "prefix": json["Lead_Source_Cell_Phone_Prefix"],
        "number": json["Lead_Source_Cell_Phone_Number"],
      });

  PhoneNumber get leadSourceOfficePhone => PhoneNumber(client, {
        "label": "office",
        "area_code": json["Lead_Source_Office_Phone_Area_Code"],
        "prefix": json["Lead_Source_Office_Phone_Prefix"],
        "number": json["Lead_Source_Office_Phone_Number"],
      });

  String get leadSourceEmail => json["Lead_Source_Email_Address"];

  PhoneNumber get salesAgentCellPhone => PhoneNumber(client, {
        "label": "cell",
        "area_code": json["Sales_Agent_Cell_Phone_Area_Code"],
        "prefix": json["Sales_Agent_Cell_Phone_Prefix"],
        "number": json["Sales_Agent_Cell_Phone_Number"],
      });

  PhoneNumber get salesAgentOfficePhone => PhoneNumber(client, {
        "label": "office",
        "area_code": json["Sales_Agent_Office_Phone_Area_Code"],
        "prefix": json["Sales_Agent_Office_Phone_Prefix"],
        "number": json["Sales_Agent_Office_Phone_Number"],
      });

  String get salesAgentEmail => json["Sales_Agent_Email_Address"];

  String get coemail => json["CoBorrower_Email_Address"];

  String get lastAttempt => json["Last_Attempt"];

  String get lastContact => json["Last_Contact"];

  List<Task> get tasks => json["Lead_Tracker_Tasks"] == null
      ? []
      : List?.from(json["Lead_Tracker_Tasks"])
              ?.map((i) => Task(client, i))
              ?.toList() ??
          [];

  bool matchesSearch(String search) {
    if (search == null || search.isEmpty) {
      return true;
    }

    search = search.toLowerCase();

    if (firstName.toLowerCase().contains(search)) {
      return true;
    }
    if (lastName.toLowerCase().contains(search)) {
      return true;
    }
    if (primaryPhone.raw().toLowerCase().contains(search)) {
      return true;
    }
    if (secondaryPhone.raw().toLowerCase().contains(search)) {
      return true;
    }
    if (email.toLowerCase().contains(search)) {
      return true;
    }
    return false;
  }

  // -- Actions --
  Future<List<Task>> listTasks({DateTime date}) {
    return client.listTasksForCoreLead(id, date: date);
  }
}
