part of unify;

class LeadGroup implements UnifyObject {
  LeadGroup(this.client, this.json);

  @override
  final UnifyClient client;

  @override
  final Map<String, dynamic> json;

  String get id => json["id"];

  String get name => json["name"];

  int get count => json["count"];

  // -- Actions --
  Future<List<Lead>> listLeads(
      {int page = 1, int rows = 100, String query = ""}) {
    return client.listLeadsForLeadGroup(id,
        page: page, rows: rows, query: query);
  }

  Future<List<String>> listEmails() {
    return client.listEmailsForLeadGroup(id);
  }

  Future edit(String name) {
    return client.editLeadGroup(id, name);
  }

  Future delete() {
    return client.deleteLeadGroup(id);
  }
}
