part of unify;


class MarketingMaterialDetails implements UnifyObject {
  MarketingMaterialDetails(this.client, this.json);

  @override
  final UnifyClient client;

  @override
  final Map<String, dynamic> json;

  String get id => json["id"];

  String get imageUrl => json["image_url"];

  String get name => json["name"];

  String get description => json["description"];

  String get type => json["type"];

  String get category => json["category"];

  String get subCategory => json["sub_category"];

  String get unit => json["unit_type"];

  String get code => json["code"];

  String get level => json["level"];

  String get state => json["state"];

  String get status => json["status"];

  DateTime get date => DateTime.tryParse(json["week"] as String);

  double get price => json["price"];

  int get mailings => json["mailings"];

  bool get coBrand => json["co_brand"];

  List<MarketingEvent> get events => json["events"] == null
      ? []
      : List?.from(json["events"])
              ?.map((i) => MarketingEvent(client, i))
              ?.toList() ??
          [];
}

class MarketingEvent implements UnifyObject {
  MarketingEvent(this.client, this.json);

  @override
  final UnifyClient client;

  @override
  final Map<String, dynamic> json;

  String get id => json["id"];

  String get imageUrl => json["image_url"];

  bool get hasImage => json["has_image"];

  String get action => json["action"];

  DateTime get date => DateTime.tryParse(json["date"] as String);

  double get price => json["price"];

  int get year => json["year"];

  int get week => json["week"];

  int get day => json["day"];

  Future<MarketingPreview> getPreview() async {
    return client.getMarketingPreview(id);
  }
}
