part of unify;

class MarketingSection implements UnifyObject {
  MarketingSection(this.client, this.json);

  @override
  final UnifyClient client;

  @override
  final Map<String, dynamic> json;

  String get name => json["type"];

  String get imageUrl => json["image_url"];

  int get count => json["count"];

  List<MarketingCategory> get items => json["items"] == null
      ? []
      : List?.from(json["items"])
              ?.map((i) => MarketingCategory(client, i))
              ?.toList() ??
          [];

  Future<List<MarketingMaterial>> listMaterial() {
    return client.listMarketingMaterial(type: name);
  }
}

class MarketingCategory implements UnifyObject {
  MarketingCategory(this.client, this.json);

  @override
  final UnifyClient client;

  @override
  final Map<String, dynamic> json;

  String get name => json["type"];

  String get type => json["marketing_type"];

  String get imageUrl => json["image_url"];

  int get count => json["count"];

  List<MarketingSubCategory> get items => json["items"] == null
      ? []
      : List?.from(json["items"])
              ?.map((i) => MarketingSubCategory(client, i))
              ?.toList() ??
          [];

  Future<List<MarketingMaterial>> listMaterial() {
    return client.listMarketingMaterial(type: type, category: name);
  }
}

class MarketingSubCategory implements UnifyObject {
  MarketingSubCategory(this.client, this.json);

  @override
  final UnifyClient client;

  @override
  final Map<String, dynamic> json;

  String get name => json["type"];

  String get type => json["marketing_type"];

  String get category => json["marketing_category"];

  String get imageUrl => json["image_url"];

  int get count => json["count"];

  Future<List<MarketingMaterial>> listMaterial() {
    return client.listMarketingMaterial(
        type: type, category: category, subCategory: name);
  }
}
